<?php 
error_reporting(0);
ini_set("display_errors",0);
add_action('admin_init', 'lda_seo_add_box');
function lda_seo_add_box() {
    add_meta_box('lda_seo_meta_box', 'nTopic', 'lda_seo_show_box', 'post', 'side', 'high');
}
function lda_seo_show_box() {
    global  $post; ?>
<style type="text/css">
    .tabButton {
        background: #E9E9E9;
        border: 1px solid #CCCCCC;
        border-bottom: none;
        font-weight: bold;
        margin-right: 2px;
        padding: 5px;
        text-decoration: none;
        border-radius: 5px 5px 0 0;
        float: left;
    }
    .tabPanel {
        height: 200px;
        overflow-y: auto;
        border: 1px solid #CCCCCC;
        padding: 5px;
    }
    .score {
        border: 1px solid #CCCCCC;
        border-radius: 5px 5px 5px 5px;
        float: right;
        margin-top: -37px;
    }
    .score b {
        color: #2175B6;
        display: block;
        font-size: 28px;
        line-height: 30px;
        padding: 3px;
        text-align: center;
    }
    .score span {
        background: #E9E9E9;
        display: block;
        font-size: 12px;
        font-weight: bold;
        line-height: 14px;
        padding: 5px 4px 3px;
        text-align: center;
        text-transform: uppercase;
        vertical-align: middle;
    }
</style>
Please <a target="_Blank" href="<?php echo get_preview_post_link(); ?>">preview post</a> before scoring!
<input type="text" value="" placeholder="Separate keywords with commas" id="lda_seo_name" name="lda_seo_name" class="widefat"/>
<input type="button" id="lda-seo-score-btn" value="Find Score" class="button-secondary" style="margin: 5px 0 0;"/>
<div id="lda_seo_results" style="margin: 10px 0;"></div>
<script type="text/javascript">         
jQuery(document).ready(function(){
    jQuery('input#lda-seo-score-btn').click(function(){
        jQuery('#lda_seo_results').html('<img src="<?php echo WP_PLUGIN_URL; ?>/nTopic/images/ajax-loader.gif" style="display: block; margin: 0 auto" />');
        jQuery.ajax({
            type: "POST",
            url: "<?php bloginfo('url')?>/wp-admin/admin-ajax.php",
            data: {
                action: "ak_attach",
                'keywords': jQuery('input#lda_seo_name').val(),
                'content': jQuery('#content').val(),
            },
            success: function(data){
                jQuery('#lda_seo_results').html(data);
                return false;
            },
            error: function(){
                jQuery('#lda_seo_results').html('<p>An unknown error occured while trying to connect to the API!</p>');
                return false;
            }
        });
        return false;
    });
});
function switchstate(index){
    for(var i = 1; document.getElementById('words'+i); i++){
        document.getElementById('words'+i).style.display = "none";
        document.getElementById('tab'+i).style.background = "#E9E9E9";
        document.getElementById('tab'+i).style.marginBottom = "0px";
        document.getElementById('tab'+i).style.paddingBottom = "5px";
    }
    document.getElementById('words'+index).style.display = "block";
    document.getElementById('tab'+index).style.background = "#F6F6F6";
    document.getElementById('tab'+index).style.marginBottom = "-1px";
    document.getElementById('tab'+index).style.paddingBottom = "6px";
}
</script>
<?php
}
?>
<?php

function gsmxml($s,$e,$c) {
    $exp = explode($s,$c);
    $f = explode($e,$exp[1]);
    return $f[0];
}

function lda_seo_ajaxResponse(){  
    try {
        $options = get_option('lda_seo_options');
        $word_count = str_word_count($_POST['content']); 
        if($word_count < 25){
            echo'<p>Please enter atleast 25 words to check your SEO score.</p>';
            exit;
        }
        $post_data = array('keyword' => str_replace(' ', '', $_POST['keywords']), 'content' => strip_tags($_POST['content']), 'apikey' => $options[API]);
        $post_fields = array();
        foreach($post_data as $key => $value) {
            $post_fields[] = $key.'='.$value;
        }
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'http://lda.seotlz.com/lda/keyword-data.php');
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, implode('&', $post_fields));
        curl_setopt($ch, CURLOPT_POST, 1);
        $result = curl_exec($ch);
        curl_close($ch);
        if(strpos($result, '<session') == false) {
            echo '<p>An unknown error occured while trying to connect to the API!</p>'; 
            exit;
        }
        //echo "<textarea>$result</textarea>";
        //echo 'tried '.implode("&",$post_fields).'<br /><br />';
        
        // Grabbing the words in the content and getting a count so we can determine percentages...
        $post_words = strtolower($_POST['content']);
        $post_words = array_count_values(str_word_count($post_words, 1));
        $stopwords = array("a", "about", "above", "above", "across", "after", "afterwards", "again", "against", "all", "almost", "alone", "along", "already", "also","although","always","am","among", "amongst", "amoungst", "amount", "an", "and", "another", "any","anyhow","anyone","anything","anyway", "anywhere", "are", "around", "as", "at", "back","be","became", "because","become","becomes", "becoming", "been", "before", "beforehand", "behind", "being", "below", "beside", "besides", "between", "beyond", "bill", "both", "bottom","but", "by", "call", "can", "cannot", "cant", "co", "con", "could", "couldnt", "cry", "de", "describe", "detail", "do", "done", "down", "due", "during", "each", "eg", "eight", "either", "eleven","else", "elsewhere", "empty", "enough", "etc", "even", "ever", "every", "everyone", "everything", "everywhere", "except", "few", "fifteen", "fify", "fill", "find", "fire", "first", "five", "for", "former", "formerly", "forty", "found", "four", "from", "front", "full", "further", "get", "give", "go", "had", "has", "hasnt", "have", "he", "hence", "her", "here", "hereafter", "hereby", "herein", "hereupon", "hers", "herself", "him", "himself", "his", "how", "however", "hundred", "ie", "if", "in", "inc", "indeed", "interest", "into", "is", "it", "its", "itself", "keep", "last", "latter", "latterly", "least", "less", "ltd", "made", "many", "may", "me", "meanwhile", "might", "mill", "mine", "more", "moreover", "most", "mostly", "move", "much", "must", "my", "myself", "name", "namely", "neither", "never", "nevertheless", "next", "nine", "no", "nobody", "none", "noone", "nor", "not", "nothing", "now", "nowhere", "of", "off", "often", "on", "once", "one", "only", "onto", "or", "other", "others", "otherwise", "our", "ours", "ourselves", "out", "over", "own","part", "per", "perhaps", "please", "put", "rather", "re", "same", "see", "seem", "seemed", "seeming", "seems", "serious", "several", "she", "should", "show", "side", "since", "sincere", "six", "sixty", "so", "some", "somehow", "someone", "something", "sometime", "sometimes", "somewhere", "still", "such", "system", "take", "ten", "than", "that", "the", "their", "them", "themselves", "then", "thence", "there", "thereafter", "thereby", "therefore", "therein", "thereupon", "these", "they", "thickv", "thin", "third", "this", "those", "though", "three", "through", "throughout", "thru", "thus", "to", "together", "too", "top", "toward", "towards", "twelve", "twenty", "two", "un", "under", "until", "up", "upon", "us", "very", "via", "was", "we", "well", "were", "what", "whatever", "when", "whence", "whenever", "where", "whereafter", "whereas", "whereby", "wherein", "whereupon", "wherever", "whether", "which", "while", "whither", "who", "whoever", "whole", "whom", "whose", "why", "will", "with", "within", "without", "would", "yet", "you", "your", "yours", "yourself", "yourselves", "the");
        $stopwords = array_flip($stopwords);        
        $actual_words = array_diff_key($post_words, $stopwords);
        
        $real_word_count = count(array_keys($actual_words));
        
       // echo "<textarea>";
       // echo "pre-filter: $word_count <br />";
       // echo "post-filter: $real_word_count<br />";
       // print_r($actual_words);
       // print_r($stopwords);
       // echo "</textarea>";
        
        $score = gsmxml("<result>","</result>",$result);
        $score = round($score*100,2);
        $words = gsmxml("<words>","</words>",$result);
        $total = gsmxml("<t>","</t>",$result);
        $wordlist = explode("\n",$words);
        
        foreach($wordlist as $word) {
            $n = gsmxml("(",")",$word);
            $p = round((100*($n/$total)),2);
            $w = strstr($word, ' ', true);
            $acount = $actual_words[$w];
            $apercent = round(100*($acount/$real_word_count),2);
            if ($apercent > ($p*.75)){$bg = "#99cc99";}else{$bg="#ffb2b2";};
            $word = str_replace("($n)","<em> - <strong>Target:</strong> <span style='background-color:$bg;'>$p% vs. $apercent%</span></em>",$word);
            $nwords[] = $word;
        }
        $negative = gsmxml("<negative>","</negative>",$result);
    
        echo '<a id="tab1" class="current tabButton" onclick="switchstate(1)" href="#" style="padding-bottom: 6px; margin-bottom: -1px;">Good Words</a>';
        echo '<a id="tab2" class="tabButton" onclick="switchstate(2)" href="#">Bad Words</a>';
        echo '<div class="score"><b>'.$score.'</b><span>Score</span></div>';
        echo '<div style="clear: both;"></div>';
        echo'<div id="words1" style="display: block;" class="tabPanel">';                
        echo implode("<br />",$nwords);
        echo'</div>';
        echo'<div id="words2" style="display: none;" class="tabPanel">';
        echo nl2br($negative);
        echo'</div>';
    } catch (Exception $e){
        echo '<p>An unknown error occured while trying to connect to the API!</p>'; 
    }
    exit;
}  
add_action('wp_ajax_ak_attach', 'lda_seo_ajaxResponse');

function lda_seo_show_words($words) {
    $words = explode("\n", $words);
    if($words) {
        $count = 0;
        foreach($words as $word) {
            if($count > 0) {
                echo '<br />';
            }
            echo $word;
            $count++;
        }
    }
}
?>
